diff -Nur openbsc.old/src/gsm_04_08.c openbsc.new/src/gsm_04_08.c
--- openbsc.old/src/gsm_04_08.c	2009-05-23 19:29:47.000000000 +0200
+++ openbsc.new/src/gsm_04_08.c	2009-05-30 16:56:47.000000000 +0200
@@ -1384,6 +1385,7 @@
 				GSM_SUBSCRIBER_UPDATE_DETACHED);
 		DEBUGP(DMM, "Subscriber: %s\n",
 		       subscr->name ? subscr->name : subscr->imsi);
+		subscr_put(subscr);
 	} else
 		DEBUGP(DMM, "Unknown Subscriber ?!?\n");
 
@@ -1469,11 +1470,16 @@
 	DEBUGP(DRR, "<- Channel was requested by %s\n",
 		subscr->name ? subscr->name : subscr->imsi);
 
-	if (!msg->lchan->subscr)
+	if (!msg->lchan->subscr) {
 		msg->lchan->subscr = subscr;
-	else if (msg->lchan->subscr != subscr) {
+	} else if (msg->lchan->subscr != subscr) {
 		DEBUGP(DRR, "<- Channel already owned by someone else?\n");
 		subscr_put(subscr);
+		return -EINVAL;
+	} else {
+		DEBUGP(DRR, "<- Channel already owned by us\n");
+		subscr_put(subscr);
+		subscr = msg->lchan->subscr;
 	}
 
 	sig_data.subscr = subscr;
diff -Nur openbsc.old/src/gsm_subscriber.c openbsc.new/src/gsm_subscriber.c
--- openbsc.old/src/gsm_subscriber.c	2009-05-23 19:21:35.000000000 +0200
+++ openbsc.new/src/gsm_subscriber.c	2009-05-24 10:49:20.000000000 +0200
@@ -27,6 +27,7 @@
 #include <string.h>
 
 #include <openbsc/gsm_subscriber.h>
+#include <openbsc/debug.h>
 #include <openbsc/db.h>
 
 
@@ -118,12 +118,17 @@
 struct gsm_subscriber *subscr_get(struct gsm_subscriber *subscr)
 {
 	subscr->use_count++;
+	DEBUGP(DCC, "subscr %s usage increases usage to: %d\n",
+			subscr->extension, subscr->use_count);
 	return subscr;
 }
 
 struct gsm_subscriber *subscr_put(struct gsm_subscriber *subscr)
 {
-	if (--subscr->use_count <= 0)
+	subscr->use_count--;
+	DEBUGP(DCC, "subscr %s usage decreased usage to: %d\n",
+			subscr->extension, subscr->use_count);
+	if (subscr->use_count <= 0)
 		subscr_free(subscr);
 	return NULL;
 }
